/*
 * counter.c
 *
 *  Created on: 25.03.2011
 *      Author: kostochkin
 */

#include "counter.h"
#include "init.h"
#include <avr/io.h>
#include "io.h"

void counter_start(int value) {
	do_times = value;
	counter_reset_up;
	high_counter_bits = 0x00;
	latch_down;
	init_timer1();
	init_timer0();
	counter_reset_down;
}

void counter_stop(void) {
	latch_up;
	TCCR0 = 0x00;
	int timer = TCNT1;
	int result_h = ((high_counter_bits<<6)&0x3FC0) | ((timer >> 10)&0x003F) ;
	int result_l = ((TCNT1<<6)&0xFFC0) | counter_low_bits;
	counter_reset_up;
	u_send_long(result_h, result_l);
	led_off;
}

void counter_read_eval(void) {
	char count = 0;
	char command;
	char symb;
	int value = 0x0000;
	while (count < 3) {
		if ((UCSRA & (1 << RXC))) {
			symb = u_gch();
			//u_pch(symb);
			switch (count) {
			case 0:
				command = symb;
				count++;
				break;
			case 1:
				value |= ((symb << 8) & 0xFF00);
				count++;
				break;
			case 2:
				value |= (symb & 0x00FF);
				count++;
				break;
			}
		}
	};
	counter_eval;
}
